# WEB+DB PRESS Vol.101 特集1「iOS 11最前線」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.101」の特集1「iOS 11最前線」（森本 利博、武井 優己著）のサンプルコードです。

本サンプルコードには、以次のコードが含まれています。

* 第1章：ドラッグ&ドロップのサンプルコード
* 第2章：Core ML、Visionのサンプルコード
* 第2章：ARKitのサンプルコード
* 第3章：Swift 4のサンプルコード集
* 第4章：HelloHexavilleプロジェクト一式

それぞれについての実行方法などの詳細について以下に記載します。

## 共通の下準備
本サンプルコードはXcode 9を使う必要があるので、ダウンロードし起動できる環境を整えておいてください。
また、実機ビルドする際にはApple IDの登録が必要となります。

次の環境で動作確認済みです。

- Xcode 9.0.0

### 実機でビルドするために
1. 該当するxcodeprojを開く
2. 「General」◆→◆「Identity」で`Bundle Identifer`を独自のものに変更する
    * 命名規則は[「iTunes Connectアプリケーションのプロパティ」](https://developer.apple.com/library/content/documentation/LanguagesUtilities/Conceptual/iTunesConnect_Guide_Jpn/Appendices/Properties.html)を参考にしてください
3. 「General」◆→◆「Signing」でTeamを選択する
    * 登録されていない場合、`command＋,`キーで設定画面を開き「Accounts」から追加できます

## 第1章　ドラッグ&ドロップのサンプルコード
第1章で紹介したドラッグ&ドロップのサンプルコードです。
画像をドラッグしたまま、別の画面に遷移、画像をドロップしてリストに画像を追加するサンプルです。

### ビルド／実行
`chapter_1/DragAndDropSample/DragAndDrop.xcodeproj`をXcodeで開くことにより、アプリのビルド／実行を行えます。
シミュレータでも動作しますが、操作方法を体験したい方は実機で試すことを推奨します。

### 操作方法（iPhone）
1. アプリを起動する
2. 右上の＋ボタンをタップする
3. ドラッグ対象の画像が表示されるのでドラッグする
4. 画像に長押しもしくは3Dタッチする
5. ドラッグを継続したまま別の指で1つ前の画面に遷移する
6. 画像の上にドロップする

### 操作方法（iPad）
iPhoneと同様のことをできます。
さらにiPadでは、画面分割を用いてアプリ間のデータ連携もサポートします。
画面分割でアプリを表示しアプリをまたいでドラッグ&ドロップできます。

## 第2章　Core ML、Visionのサンプルコード
第2章で紹介したCore MLとVisionのサンプルコードです。

### ビルド／実行
1. `chapter_2/MachineLearningSample/MachineLearningSample.xcodeproj`をXcodeで開く
2. [「Machine Learning - Apple Developer」](https://developer.apple.com/machine-learning/)から`MobileNet`をダウンロードする
3. プロジェクトナビゲータに`MobileNet.mlmodel`をドラッグ&ドロップして追加する
4. ユーティリティエリアにあるTarget MembershipでMachineLearningSampleを選択する

以上で、アプリのビルド／実行ができます。
カメラ入力を利用しているため、実機のみで動作します。

### 操作方法
1. アプリを起動する
2. 「Core ML Sample」または「Vision Sample」を選択する
3. 「Vision Sampleの場合、カメラ入力を利用するのでダイアログで許可を選択する

## 第2章　ARKitのサンプルコード

第2章で紹介したARKitのサンプルコードです。
平面認識が完了後、画面をタップすると飛行機がタップした数だけ出現するサンプルです。

### ビルド／実行
`chapter_2/ARKitSample/ARKitSample.xcodeproj`をXcodeで開くことにより、アプリのビルド／実行を行えます。
カメラ入力を利用しているため、実機のみで動作します。

### 操作方法
1. アプリを起動する
2. 明るいところで机など水平面を撮影する
3. 画面に飛行機が出現する
4. 画面をタップすると新しく飛行機が出現する

## 第3章　Swift 4のサンプルコード集

第3章で紹介したSwift 4のサンプルコード集です。Playground形式で配布しているため、`chapter_3/Swift4-Sample-Code.playground`をダブルクリックや`open`コマンドで開いてください。

### 実行方法
PlaygroundをXcodeで開くことで、自動的に実行されます。

## 第4章　HelloHexavilleプロジェクト一式

第4章で紹介した`HelloHexaville`プロジェクト一式が`chapter_4/HelloHexaville`にあります。これは、`hexaville generate HelloHexaville`コマンドで作成したものと同様です。

詳しい実行方法は、[HexavilleのREADME](https://github.com/noppoMan/Hexaville)を参照してください。

### Hexavilleを使ったより実践的なサンプルアプリケーション

[HexavilleTODOExample](https://github.com/noppoMan/HexavilleTODOExample)では、次の機能を盛り込んだ、より実践的なWebアプリケーションをご覧いただけます。

* GitHubのOAuthを使ったユーザー認証機能
* Amazon DynamoDBを使ったデータの永続化
* サーバサイドでの動的なHTMLレンダリング

`git clone`をしたあと、READMEに沿うことで、ローカルでのサーバ起動と実際にAWS（Amazon Web Services）へデプロイし、インターネット経由でアクセスすることもできます。

